
package at.gv.zustellung.zusemsg.xsd.zuse;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.XmlValue;
import javax.xml.bind.annotation.adapters.CollapsedStringAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import javax.xml.datatype.XMLGregorianCalendar;
import at.gv.zustellung.zusemsg.xsd.saml.AssertionType;
import at.gv.zustellung.zusemsg.xsd.xmldsig.SignatureType;


/**
 * <p>Java class for DeliveryNotificationType complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="DeliveryNotificationType">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;choice>
 *           &lt;element name="Success">
 *             &lt;complexType>
 *               &lt;complexContent>
 *                 &lt;extension base="{http://reference.e-government.gv.at/namespace/zustellung/msg}DeliveryAnswerType">
 *                   &lt;sequence>
 *                     &lt;element ref="{http://reference.e-government.gv.at/namespace/zustellung/msg}Sender"/>
 *                     &lt;element ref="{http://reference.e-government.gv.at/namespace/zustellung/msg}Receiver"/>
 *                     &lt;element name="NotificationsPerformed">
 *                       &lt;complexType>
 *                         &lt;complexContent>
 *                           &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                             &lt;sequence>
 *                               &lt;element name="RecipientNotification" maxOccurs="unbounded">
 *                                 &lt;complexType>
 *                                   &lt;complexContent>
 *                                     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                                       &lt;sequence>
 *                                         &lt;element name="NotificationMethod">
 *                                           &lt;simpleType>
 *                                             &lt;restriction base="{http://www.w3.org/2001/XMLSchema}token">
 *                                               &lt;enumeration value="electronic"/>
 *                                               &lt;enumeration value="paperbased"/>
 *                                             &lt;/restriction>
 *                                           &lt;/simpleType>
 *                                         &lt;/element>
 *                                         &lt;element name="Timestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
 *                                       &lt;/sequence>
 *                                     &lt;/restriction>
 *                                   &lt;/complexContent>
 *                                 &lt;/complexType>
 *                               &lt;/element>
 *                             &lt;/sequence>
 *                           &lt;/restriction>
 *                         &lt;/complexContent>
 *                       &lt;/complexType>
 *                     &lt;/element>
 *                     &lt;element name="ConfirmationTimestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
 *                     &lt;choice>
 *                       &lt;element name="AuthBlock" type="{urn:oasis:names:tc:SAML:1.0:assertion}AssertionType"/>
 *                       &lt;element name="BinaryConfirmation">
 *                         &lt;complexType>
 *                           &lt;simpleContent>
 *                             &lt;extension base="&lt;http://www.w3.org/2001/XMLSchema>base64Binary">
 *                               &lt;attribute name="Type" use="required" type="{http://www.w3.org/2001/XMLSchema}anySimpleType" />
 *                             &lt;/extension>
 *                           &lt;/simpleContent>
 *                         &lt;/complexType>
 *                       &lt;/element>
 *                     &lt;/choice>
 *                     &lt;element ref="{http://www.w3.org/2000/09/xmldsig#}Signature"/>
 *                   &lt;/sequence>
 *                 &lt;/extension>
 *               &lt;/complexContent>
 *             &lt;/complexType>
 *           &lt;/element>
 *           &lt;element name="Error">
 *             &lt;complexType>
 *               &lt;complexContent>
 *                 &lt;extension base="{http://reference.e-government.gv.at/namespace/zustellung/msg}DeliveryAnswerType">
 *                   &lt;sequence>
 *                     &lt;element ref="{http://reference.e-government.gv.at/namespace/zustellung/msg}Sender"/>
 *                     &lt;element ref="{http://reference.e-government.gv.at/namespace/zustellung/msg}Receiver"/>
 *                     &lt;element name="NotificationsPerformed">
 *                       &lt;complexType>
 *                         &lt;complexContent>
 *                           &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                             &lt;sequence>
 *                               &lt;element name="RecipientNotification" maxOccurs="unbounded" minOccurs="0">
 *                                 &lt;complexType>
 *                                   &lt;complexContent>
 *                                     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                                       &lt;sequence>
 *                                         &lt;element name="NotificationMethod">
 *                                           &lt;simpleType>
 *                                             &lt;restriction base="{http://www.w3.org/2001/XMLSchema}token">
 *                                               &lt;enumeration value="electronic"/>
 *                                               &lt;enumeration value="paperbased"/>
 *                                             &lt;/restriction>
 *                                           &lt;/simpleType>
 *                                         &lt;/element>
 *                                         &lt;element name="Timestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
 *                                       &lt;/sequence>
 *                                     &lt;/restriction>
 *                                   &lt;/complexContent>
 *                                 &lt;/complexType>
 *                               &lt;/element>
 *                             &lt;/sequence>
 *                           &lt;/restriction>
 *                         &lt;/complexContent>
 *                       &lt;/complexType>
 *                     &lt;/element>
 *                     &lt;element name="ErrorInfo">
 *                       &lt;complexType>
 *                         &lt;complexContent>
 *                           &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                             &lt;sequence>
 *                               &lt;element name="Code" type="{http://www.w3.org/2001/XMLSchema}positiveInteger"/>
 *                               &lt;element name="Text" type="{http://reference.e-government.gv.at/namespace/zustellung/msg}string255"/>
 *                             &lt;/sequence>
 *                           &lt;/restriction>
 *                         &lt;/complexContent>
 *                       &lt;/complexType>
 *                     &lt;/element>
 *                     &lt;element ref="{http://www.w3.org/2000/09/xmldsig#}Signature"/>
 *                   &lt;/sequence>
 *                 &lt;/extension>
 *               &lt;/complexContent>
 *             &lt;/complexType>
 *           &lt;/element>
 *         &lt;/choice>
 *         &lt;element name="AdditionalFormat" maxOccurs="unbounded" minOccurs="0">
 *           &lt;complexType>
 *             &lt;simpleContent>
 *               &lt;extension base="&lt;http://www.w3.org/2001/XMLSchema>base64Binary">
 *                 &lt;attribute name="Type" use="required" type="{http://www.w3.org/2001/XMLSchema}anySimpleType" />
 *               &lt;/extension>
 *             &lt;/simpleContent>
 *           &lt;/complexType>
 *         &lt;/element>
 *       &lt;/sequence>
 *       &lt;attribute name="version">
 *         &lt;simpleType>
 *           &lt;restriction base="{http://reference.e-government.gv.at/namespace/zustellung/msg}token255">
 *             &lt;enumeration value="1.3.0"/>
 *           &lt;/restriction>
 *         &lt;/simpleType>
 *       &lt;/attribute>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "DeliveryNotificationType", propOrder = {
    "success",
    "error",
    "additionalFormat"
})
@XmlSeeAlso({
    DeliveryNotification.class
})
public class DeliveryNotificationType {

    @XmlElement(name = "Success")
    protected DeliveryNotificationType.Success success;
    @XmlElement(name = "Error")
    protected DeliveryNotificationType.Error error;
    @XmlElement(name = "AdditionalFormat")
    protected List<DeliveryNotificationType.AdditionalFormat> additionalFormat;
    @XmlAttribute
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    protected String version;

    /**
     * Gets the value of the success property.
     * 
     * @return
     *     possible object is
     *     {@link DeliveryNotificationType.Success }
     *     
     */
    public DeliveryNotificationType.Success getSuccess() {
        return success;
    }

    /**
     * Sets the value of the success property.
     * 
     * @param value
     *     allowed object is
     *     {@link DeliveryNotificationType.Success }
     *     
     */
    public void setSuccess(DeliveryNotificationType.Success value) {
        this.success = value;
    }

    /**
     * Gets the value of the error property.
     * 
     * @return
     *     possible object is
     *     {@link DeliveryNotificationType.Error }
     *     
     */
    public DeliveryNotificationType.Error getError() {
        return error;
    }

    /**
     * Sets the value of the error property.
     * 
     * @param value
     *     allowed object is
     *     {@link DeliveryNotificationType.Error }
     *     
     */
    public void setError(DeliveryNotificationType.Error value) {
        this.error = value;
    }

    /**
     * Gets the value of the additionalFormat property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the additionalFormat property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getAdditionalFormat().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link DeliveryNotificationType.AdditionalFormat }
     * 
     * 
     */
    public List<DeliveryNotificationType.AdditionalFormat> getAdditionalFormat() {
        if (additionalFormat == null) {
            additionalFormat = new ArrayList<DeliveryNotificationType.AdditionalFormat>();
        }
        return this.additionalFormat;
    }

    /**
     * Gets the value of the version property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getVersion() {
        return version;
    }

    /**
     * Sets the value of the version property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setVersion(String value) {
        this.version = value;
    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType>
     *   &lt;simpleContent>
     *     &lt;extension base="&lt;http://www.w3.org/2001/XMLSchema>base64Binary">
     *       &lt;attribute name="Type" use="required" type="{http://www.w3.org/2001/XMLSchema}anySimpleType" />
     *     &lt;/extension>
     *   &lt;/simpleContent>
     * &lt;/complexType>
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "value"
    })
    public static class AdditionalFormat {

        @XmlValue
        protected byte[] value;
        @XmlAttribute(name = "Type", required = true)
        @XmlSchemaType(name = "anySimpleType")
        protected String type;

        /**
         * Gets the value of the value property.
         * 
         * @return
         *     possible object is
         *     byte[]
         */
        public byte[] getValue() {
            return value;
        }

        /**
         * Sets the value of the value property.
         * 
         * @param value
         *     allowed object is
         *     byte[]
         */
        public void setValue(byte[] value) {
            this.value = ((byte[]) value);
        }

        /**
         * Gets the value of the type property.
         * 
         * @return
         *     possible object is
         *     {@link String }
         *     
         */
        public String getType() {
            return type;
        }

        /**
         * Sets the value of the type property.
         * 
         * @param value
         *     allowed object is
         *     {@link String }
         *     
         */
        public void setType(String value) {
            this.type = value;
        }

    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType>
     *   &lt;complexContent>
     *     &lt;extension base="{http://reference.e-government.gv.at/namespace/zustellung/msg}DeliveryAnswerType">
     *       &lt;sequence>
     *         &lt;element ref="{http://reference.e-government.gv.at/namespace/zustellung/msg}Sender"/>
     *         &lt;element ref="{http://reference.e-government.gv.at/namespace/zustellung/msg}Receiver"/>
     *         &lt;element name="NotificationsPerformed">
     *           &lt;complexType>
     *             &lt;complexContent>
     *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
     *                 &lt;sequence>
     *                   &lt;element name="RecipientNotification" maxOccurs="unbounded" minOccurs="0">
     *                     &lt;complexType>
     *                       &lt;complexContent>
     *                         &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
     *                           &lt;sequence>
     *                             &lt;element name="NotificationMethod">
     *                               &lt;simpleType>
     *                                 &lt;restriction base="{http://www.w3.org/2001/XMLSchema}token">
     *                                   &lt;enumeration value="electronic"/>
     *                                   &lt;enumeration value="paperbased"/>
     *                                 &lt;/restriction>
     *                               &lt;/simpleType>
     *                             &lt;/element>
     *                             &lt;element name="Timestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
     *                           &lt;/sequence>
     *                         &lt;/restriction>
     *                       &lt;/complexContent>
     *                     &lt;/complexType>
     *                   &lt;/element>
     *                 &lt;/sequence>
     *               &lt;/restriction>
     *             &lt;/complexContent>
     *           &lt;/complexType>
     *         &lt;/element>
     *         &lt;element name="ErrorInfo">
     *           &lt;complexType>
     *             &lt;complexContent>
     *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
     *                 &lt;sequence>
     *                   &lt;element name="Code" type="{http://www.w3.org/2001/XMLSchema}positiveInteger"/>
     *                   &lt;element name="Text" type="{http://reference.e-government.gv.at/namespace/zustellung/msg}string255"/>
     *                 &lt;/sequence>
     *               &lt;/restriction>
     *             &lt;/complexContent>
     *           &lt;/complexType>
     *         &lt;/element>
     *         &lt;element ref="{http://www.w3.org/2000/09/xmldsig#}Signature"/>
     *       &lt;/sequence>
     *     &lt;/extension>
     *   &lt;/complexContent>
     * &lt;/complexType>
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "sender",
        "receiver",
        "notificationsPerformed",
        "errorInfo",
        "signature"
    })
    public static class Error
        extends DeliveryAnswerType
    {

        @XmlElement(name = "Sender", required = true)
        protected Sender sender;
        @XmlElement(name = "Receiver", required = true)
        protected Receiver receiver;
        @XmlElement(name = "NotificationsPerformed", required = true)
        protected DeliveryNotificationType.Error.NotificationsPerformed notificationsPerformed;
        @XmlElement(name = "ErrorInfo", required = true)
        protected DeliveryNotificationType.Error.ErrorInfo errorInfo;
        @XmlElement(name = "Signature", namespace = "http://www.w3.org/2000/09/xmldsig#", required = true)
        protected SignatureType signature;

        /**
         * Gets the value of the sender property.
         * 
         * @return
         *     possible object is
         *     {@link Sender }
         *     
         */
        public Sender getSender() {
            return sender;
        }

        /**
         * Sets the value of the sender property.
         * 
         * @param value
         *     allowed object is
         *     {@link Sender }
         *     
         */
        public void setSender(Sender value) {
            this.sender = value;
        }

        /**
         * Gets the value of the receiver property.
         * 
         * @return
         *     possible object is
         *     {@link Receiver }
         *     
         */
        public Receiver getReceiver() {
            return receiver;
        }

        /**
         * Sets the value of the receiver property.
         * 
         * @param value
         *     allowed object is
         *     {@link Receiver }
         *     
         */
        public void setReceiver(Receiver value) {
            this.receiver = value;
        }

        /**
         * Gets the value of the notificationsPerformed property.
         * 
         * @return
         *     possible object is
         *     {@link DeliveryNotificationType.Error.NotificationsPerformed }
         *     
         */
        public DeliveryNotificationType.Error.NotificationsPerformed getNotificationsPerformed() {
            return notificationsPerformed;
        }

        /**
         * Sets the value of the notificationsPerformed property.
         * 
         * @param value
         *     allowed object is
         *     {@link DeliveryNotificationType.Error.NotificationsPerformed }
         *     
         */
        public void setNotificationsPerformed(DeliveryNotificationType.Error.NotificationsPerformed value) {
            this.notificationsPerformed = value;
        }

        /**
         * Gets the value of the errorInfo property.
         * 
         * @return
         *     possible object is
         *     {@link DeliveryNotificationType.Error.ErrorInfo }
         *     
         */
        public DeliveryNotificationType.Error.ErrorInfo getErrorInfo() {
            return errorInfo;
        }

        /**
         * Sets the value of the errorInfo property.
         * 
         * @param value
         *     allowed object is
         *     {@link DeliveryNotificationType.Error.ErrorInfo }
         *     
         */
        public void setErrorInfo(DeliveryNotificationType.Error.ErrorInfo value) {
            this.errorInfo = value;
        }

        /**
         * Gets the value of the signature property.
         * 
         * @return
         *     possible object is
         *     {@link SignatureType }
         *     
         */
        public SignatureType getSignature() {
            return signature;
        }

        /**
         * Sets the value of the signature property.
         * 
         * @param value
         *     allowed object is
         *     {@link SignatureType }
         *     
         */
        public void setSignature(SignatureType value) {
            this.signature = value;
        }


        /**
         * <p>Java class for anonymous complex type.
         * 
         * <p>The following schema fragment specifies the expected content contained within this class.
         * 
         * <pre>
         * &lt;complexType>
         *   &lt;complexContent>
         *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
         *       &lt;sequence>
         *         &lt;element name="Code" type="{http://www.w3.org/2001/XMLSchema}positiveInteger"/>
         *         &lt;element name="Text" type="{http://reference.e-government.gv.at/namespace/zustellung/msg}string255"/>
         *       &lt;/sequence>
         *     &lt;/restriction>
         *   &lt;/complexContent>
         * &lt;/complexType>
         * </pre>
         * 
         * 
         */
        @XmlAccessorType(XmlAccessType.FIELD)
        @XmlType(name = "", propOrder = {
            "code",
            "text"
        })
        public static class ErrorInfo {

            @XmlElement(name = "Code", required = true)
            @XmlSchemaType(name = "positiveInteger")
            protected BigInteger code;
            @XmlElement(name = "Text", required = true)
            protected String text;

            /**
             * Gets the value of the code property.
             * 
             * @return
             *     possible object is
             *     {@link BigInteger }
             *     
             */
            public BigInteger getCode() {
                return code;
            }

            /**
             * Sets the value of the code property.
             * 
             * @param value
             *     allowed object is
             *     {@link BigInteger }
             *     
             */
            public void setCode(BigInteger value) {
                this.code = value;
            }

            /**
             * Gets the value of the text property.
             * 
             * @return
             *     possible object is
             *     {@link String }
             *     
             */
            public String getText() {
                return text;
            }

            /**
             * Sets the value of the text property.
             * 
             * @param value
             *     allowed object is
             *     {@link String }
             *     
             */
            public void setText(String value) {
                this.text = value;
            }

        }


        /**
         * <p>Java class for anonymous complex type.
         * 
         * <p>The following schema fragment specifies the expected content contained within this class.
         * 
         * <pre>
         * &lt;complexType>
         *   &lt;complexContent>
         *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
         *       &lt;sequence>
         *         &lt;element name="RecipientNotification" maxOccurs="unbounded" minOccurs="0">
         *           &lt;complexType>
         *             &lt;complexContent>
         *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
         *                 &lt;sequence>
         *                   &lt;element name="NotificationMethod">
         *                     &lt;simpleType>
         *                       &lt;restriction base="{http://www.w3.org/2001/XMLSchema}token">
         *                         &lt;enumeration value="electronic"/>
         *                         &lt;enumeration value="paperbased"/>
         *                       &lt;/restriction>
         *                     &lt;/simpleType>
         *                   &lt;/element>
         *                   &lt;element name="Timestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
         *                 &lt;/sequence>
         *               &lt;/restriction>
         *             &lt;/complexContent>
         *           &lt;/complexType>
         *         &lt;/element>
         *       &lt;/sequence>
         *     &lt;/restriction>
         *   &lt;/complexContent>
         * &lt;/complexType>
         * </pre>
         * 
         * 
         */
        @XmlAccessorType(XmlAccessType.FIELD)
        @XmlType(name = "", propOrder = {
            "recipientNotification"
        })
        public static class NotificationsPerformed {

            @XmlElement(name = "RecipientNotification")
            protected List<DeliveryNotificationType.Error.NotificationsPerformed.RecipientNotification> recipientNotification;

            /**
             * Gets the value of the recipientNotification property.
             * 
             * <p>
             * This accessor method returns a reference to the live list,
             * not a snapshot. Therefore any modification you make to the
             * returned list will be present inside the JAXB object.
             * This is why there is not a <CODE>set</CODE> method for the recipientNotification property.
             * 
             * <p>
             * For example, to add a new item, do as follows:
             * <pre>
             *    getRecipientNotification().add(newItem);
             * </pre>
             * 
             * 
             * <p>
             * Objects of the following type(s) are allowed in the list
             * {@link DeliveryNotificationType.Error.NotificationsPerformed.RecipientNotification }
             * 
             * 
             */
            public List<DeliveryNotificationType.Error.NotificationsPerformed.RecipientNotification> getRecipientNotification() {
                if (recipientNotification == null) {
                    recipientNotification = new ArrayList<DeliveryNotificationType.Error.NotificationsPerformed.RecipientNotification>();
                }
                return this.recipientNotification;
            }


            /**
             * <p>Java class for anonymous complex type.
             * 
             * <p>The following schema fragment specifies the expected content contained within this class.
             * 
             * <pre>
             * &lt;complexType>
             *   &lt;complexContent>
             *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
             *       &lt;sequence>
             *         &lt;element name="NotificationMethod">
             *           &lt;simpleType>
             *             &lt;restriction base="{http://www.w3.org/2001/XMLSchema}token">
             *               &lt;enumeration value="electronic"/>
             *               &lt;enumeration value="paperbased"/>
             *             &lt;/restriction>
             *           &lt;/simpleType>
             *         &lt;/element>
             *         &lt;element name="Timestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
             *       &lt;/sequence>
             *     &lt;/restriction>
             *   &lt;/complexContent>
             * &lt;/complexType>
             * </pre>
             * 
             * 
             */
            @XmlAccessorType(XmlAccessType.FIELD)
            @XmlType(name = "", propOrder = {
                "notificationMethod",
                "timestamp"
            })
            public static class RecipientNotification {

                @XmlElement(name = "NotificationMethod", required = true)
                @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
                protected String notificationMethod;
                @XmlElement(name = "Timestamp", required = true)
                @XmlSchemaType(name = "dateTime")
                protected XMLGregorianCalendar timestamp;

                /**
                 * Gets the value of the notificationMethod property.
                 * 
                 * @return
                 *     possible object is
                 *     {@link String }
                 *     
                 */
                public String getNotificationMethod() {
                    return notificationMethod;
                }

                /**
                 * Sets the value of the notificationMethod property.
                 * 
                 * @param value
                 *     allowed object is
                 *     {@link String }
                 *     
                 */
                public void setNotificationMethod(String value) {
                    this.notificationMethod = value;
                }

                /**
                 * Gets the value of the timestamp property.
                 * 
                 * @return
                 *     possible object is
                 *     {@link XMLGregorianCalendar }
                 *     
                 */
                public XMLGregorianCalendar getTimestamp() {
                    return timestamp;
                }

                /**
                 * Sets the value of the timestamp property.
                 * 
                 * @param value
                 *     allowed object is
                 *     {@link XMLGregorianCalendar }
                 *     
                 */
                public void setTimestamp(XMLGregorianCalendar value) {
                    this.timestamp = value;
                }

            }

        }

    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType>
     *   &lt;complexContent>
     *     &lt;extension base="{http://reference.e-government.gv.at/namespace/zustellung/msg}DeliveryAnswerType">
     *       &lt;sequence>
     *         &lt;element ref="{http://reference.e-government.gv.at/namespace/zustellung/msg}Sender"/>
     *         &lt;element ref="{http://reference.e-government.gv.at/namespace/zustellung/msg}Receiver"/>
     *         &lt;element name="NotificationsPerformed">
     *           &lt;complexType>
     *             &lt;complexContent>
     *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
     *                 &lt;sequence>
     *                   &lt;element name="RecipientNotification" maxOccurs="unbounded">
     *                     &lt;complexType>
     *                       &lt;complexContent>
     *                         &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
     *                           &lt;sequence>
     *                             &lt;element name="NotificationMethod">
     *                               &lt;simpleType>
     *                                 &lt;restriction base="{http://www.w3.org/2001/XMLSchema}token">
     *                                   &lt;enumeration value="electronic"/>
     *                                   &lt;enumeration value="paperbased"/>
     *                                 &lt;/restriction>
     *                               &lt;/simpleType>
     *                             &lt;/element>
     *                             &lt;element name="Timestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
     *                           &lt;/sequence>
     *                         &lt;/restriction>
     *                       &lt;/complexContent>
     *                     &lt;/complexType>
     *                   &lt;/element>
     *                 &lt;/sequence>
     *               &lt;/restriction>
     *             &lt;/complexContent>
     *           &lt;/complexType>
     *         &lt;/element>
     *         &lt;element name="ConfirmationTimestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
     *         &lt;choice>
     *           &lt;element name="AuthBlock" type="{urn:oasis:names:tc:SAML:1.0:assertion}AssertionType"/>
     *           &lt;element name="BinaryConfirmation">
     *             &lt;complexType>
     *               &lt;simpleContent>
     *                 &lt;extension base="&lt;http://www.w3.org/2001/XMLSchema>base64Binary">
     *                   &lt;attribute name="Type" use="required" type="{http://www.w3.org/2001/XMLSchema}anySimpleType" />
     *                 &lt;/extension>
     *               &lt;/simpleContent>
     *             &lt;/complexType>
     *           &lt;/element>
     *         &lt;/choice>
     *         &lt;element ref="{http://www.w3.org/2000/09/xmldsig#}Signature"/>
     *       &lt;/sequence>
     *     &lt;/extension>
     *   &lt;/complexContent>
     * &lt;/complexType>
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "sender",
        "receiver",
        "notificationsPerformed",
        "confirmationTimestamp",
        "authBlock",
        "binaryConfirmation",
        "signature"
    })
    public static class Success
        extends DeliveryAnswerType
    {

        @XmlElement(name = "Sender", required = true)
        protected Sender sender;
        @XmlElement(name = "Receiver", required = true)
        protected Receiver receiver;
        @XmlElement(name = "NotificationsPerformed", required = true)
        protected DeliveryNotificationType.Success.NotificationsPerformed notificationsPerformed;
        @XmlElement(name = "ConfirmationTimestamp", required = true)
        @XmlSchemaType(name = "dateTime")
        protected XMLGregorianCalendar confirmationTimestamp;
        @XmlElement(name = "AuthBlock")
        protected AssertionType authBlock;
        @XmlElement(name = "BinaryConfirmation")
        protected DeliveryNotificationType.Success.BinaryConfirmation binaryConfirmation;
        @XmlElement(name = "Signature", namespace = "http://www.w3.org/2000/09/xmldsig#", required = true)
        protected SignatureType signature;

        /**
         * Gets the value of the sender property.
         * 
         * @return
         *     possible object is
         *     {@link Sender }
         *     
         */
        public Sender getSender() {
            return sender;
        }

        /**
         * Sets the value of the sender property.
         * 
         * @param value
         *     allowed object is
         *     {@link Sender }
         *     
         */
        public void setSender(Sender value) {
            this.sender = value;
        }

        /**
         * Gets the value of the receiver property.
         * 
         * @return
         *     possible object is
         *     {@link Receiver }
         *     
         */
        public Receiver getReceiver() {
            return receiver;
        }

        /**
         * Sets the value of the receiver property.
         * 
         * @param value
         *     allowed object is
         *     {@link Receiver }
         *     
         */
        public void setReceiver(Receiver value) {
            this.receiver = value;
        }

        /**
         * Gets the value of the notificationsPerformed property.
         * 
         * @return
         *     possible object is
         *     {@link DeliveryNotificationType.Success.NotificationsPerformed }
         *     
         */
        public DeliveryNotificationType.Success.NotificationsPerformed getNotificationsPerformed() {
            return notificationsPerformed;
        }

        /**
         * Sets the value of the notificationsPerformed property.
         * 
         * @param value
         *     allowed object is
         *     {@link DeliveryNotificationType.Success.NotificationsPerformed }
         *     
         */
        public void setNotificationsPerformed(DeliveryNotificationType.Success.NotificationsPerformed value) {
            this.notificationsPerformed = value;
        }

        /**
         * Gets the value of the confirmationTimestamp property.
         * 
         * @return
         *     possible object is
         *     {@link XMLGregorianCalendar }
         *     
         */
        public XMLGregorianCalendar getConfirmationTimestamp() {
            return confirmationTimestamp;
        }

        /**
         * Sets the value of the confirmationTimestamp property.
         * 
         * @param value
         *     allowed object is
         *     {@link XMLGregorianCalendar }
         *     
         */
        public void setConfirmationTimestamp(XMLGregorianCalendar value) {
            this.confirmationTimestamp = value;
        }

        /**
         * Gets the value of the authBlock property.
         * 
         * @return
         *     possible object is
         *     {@link AssertionType }
         *     
         */
        public AssertionType getAuthBlock() {
            return authBlock;
        }

        /**
         * Sets the value of the authBlock property.
         * 
         * @param value
         *     allowed object is
         *     {@link AssertionType }
         *     
         */
        public void setAuthBlock(AssertionType value) {
            this.authBlock = value;
        }

        /**
         * Gets the value of the binaryConfirmation property.
         * 
         * @return
         *     possible object is
         *     {@link DeliveryNotificationType.Success.BinaryConfirmation }
         *     
         */
        public DeliveryNotificationType.Success.BinaryConfirmation getBinaryConfirmation() {
            return binaryConfirmation;
        }

        /**
         * Sets the value of the binaryConfirmation property.
         * 
         * @param value
         *     allowed object is
         *     {@link DeliveryNotificationType.Success.BinaryConfirmation }
         *     
         */
        public void setBinaryConfirmation(DeliveryNotificationType.Success.BinaryConfirmation value) {
            this.binaryConfirmation = value;
        }

        /**
         * Gets the value of the signature property.
         * 
         * @return
         *     possible object is
         *     {@link SignatureType }
         *     
         */
        public SignatureType getSignature() {
            return signature;
        }

        /**
         * Sets the value of the signature property.
         * 
         * @param value
         *     allowed object is
         *     {@link SignatureType }
         *     
         */
        public void setSignature(SignatureType value) {
            this.signature = value;
        }


        /**
         * <p>Java class for anonymous complex type.
         * 
         * <p>The following schema fragment specifies the expected content contained within this class.
         * 
         * <pre>
         * &lt;complexType>
         *   &lt;simpleContent>
         *     &lt;extension base="&lt;http://www.w3.org/2001/XMLSchema>base64Binary">
         *       &lt;attribute name="Type" use="required" type="{http://www.w3.org/2001/XMLSchema}anySimpleType" />
         *     &lt;/extension>
         *   &lt;/simpleContent>
         * &lt;/complexType>
         * </pre>
         * 
         * 
         */
        @XmlAccessorType(XmlAccessType.FIELD)
        @XmlType(name = "", propOrder = {
            "value"
        })
        public static class BinaryConfirmation {

            @XmlValue
            protected byte[] value;
            @XmlAttribute(name = "Type", required = true)
            @XmlSchemaType(name = "anySimpleType")
            protected String type;

            /**
             * Gets the value of the value property.
             * 
             * @return
             *     possible object is
             *     byte[]
             */
            public byte[] getValue() {
                return value;
            }

            /**
             * Sets the value of the value property.
             * 
             * @param value
             *     allowed object is
             *     byte[]
             */
            public void setValue(byte[] value) {
                this.value = ((byte[]) value);
            }

            /**
             * Gets the value of the type property.
             * 
             * @return
             *     possible object is
             *     {@link String }
             *     
             */
            public String getType() {
                return type;
            }

            /**
             * Sets the value of the type property.
             * 
             * @param value
             *     allowed object is
             *     {@link String }
             *     
             */
            public void setType(String value) {
                this.type = value;
            }

        }


        /**
         * <p>Java class for anonymous complex type.
         * 
         * <p>The following schema fragment specifies the expected content contained within this class.
         * 
         * <pre>
         * &lt;complexType>
         *   &lt;complexContent>
         *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
         *       &lt;sequence>
         *         &lt;element name="RecipientNotification" maxOccurs="unbounded">
         *           &lt;complexType>
         *             &lt;complexContent>
         *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
         *                 &lt;sequence>
         *                   &lt;element name="NotificationMethod">
         *                     &lt;simpleType>
         *                       &lt;restriction base="{http://www.w3.org/2001/XMLSchema}token">
         *                         &lt;enumeration value="electronic"/>
         *                         &lt;enumeration value="paperbased"/>
         *                       &lt;/restriction>
         *                     &lt;/simpleType>
         *                   &lt;/element>
         *                   &lt;element name="Timestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
         *                 &lt;/sequence>
         *               &lt;/restriction>
         *             &lt;/complexContent>
         *           &lt;/complexType>
         *         &lt;/element>
         *       &lt;/sequence>
         *     &lt;/restriction>
         *   &lt;/complexContent>
         * &lt;/complexType>
         * </pre>
         * 
         * 
         */
        @XmlAccessorType(XmlAccessType.FIELD)
        @XmlType(name = "", propOrder = {
            "recipientNotification"
        })
        public static class NotificationsPerformed {

            @XmlElement(name = "RecipientNotification", required = true)
            protected List<DeliveryNotificationType.Success.NotificationsPerformed.RecipientNotification> recipientNotification;

            /**
             * Gets the value of the recipientNotification property.
             * 
             * <p>
             * This accessor method returns a reference to the live list,
             * not a snapshot. Therefore any modification you make to the
             * returned list will be present inside the JAXB object.
             * This is why there is not a <CODE>set</CODE> method for the recipientNotification property.
             * 
             * <p>
             * For example, to add a new item, do as follows:
             * <pre>
             *    getRecipientNotification().add(newItem);
             * </pre>
             * 
             * 
             * <p>
             * Objects of the following type(s) are allowed in the list
             * {@link DeliveryNotificationType.Success.NotificationsPerformed.RecipientNotification }
             * 
             * 
             */
            public List<DeliveryNotificationType.Success.NotificationsPerformed.RecipientNotification> getRecipientNotification() {
                if (recipientNotification == null) {
                    recipientNotification = new ArrayList<DeliveryNotificationType.Success.NotificationsPerformed.RecipientNotification>();
                }
                return this.recipientNotification;
            }


            /**
             * <p>Java class for anonymous complex type.
             * 
             * <p>The following schema fragment specifies the expected content contained within this class.
             * 
             * <pre>
             * &lt;complexType>
             *   &lt;complexContent>
             *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
             *       &lt;sequence>
             *         &lt;element name="NotificationMethod">
             *           &lt;simpleType>
             *             &lt;restriction base="{http://www.w3.org/2001/XMLSchema}token">
             *               &lt;enumeration value="electronic"/>
             *               &lt;enumeration value="paperbased"/>
             *             &lt;/restriction>
             *           &lt;/simpleType>
             *         &lt;/element>
             *         &lt;element name="Timestamp" type="{http://www.w3.org/2001/XMLSchema}dateTime"/>
             *       &lt;/sequence>
             *     &lt;/restriction>
             *   &lt;/complexContent>
             * &lt;/complexType>
             * </pre>
             * 
             * 
             */
            @XmlAccessorType(XmlAccessType.FIELD)
            @XmlType(name = "", propOrder = {
                "notificationMethod",
                "timestamp"
            })
            public static class RecipientNotification {

                @XmlElement(name = "NotificationMethod", required = true)
                @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
                protected String notificationMethod;
                @XmlElement(name = "Timestamp", required = true)
                @XmlSchemaType(name = "dateTime")
                protected XMLGregorianCalendar timestamp;

                /**
                 * Gets the value of the notificationMethod property.
                 * 
                 * @return
                 *     possible object is
                 *     {@link String }
                 *     
                 */
                public String getNotificationMethod() {
                    return notificationMethod;
                }

                /**
                 * Sets the value of the notificationMethod property.
                 * 
                 * @param value
                 *     allowed object is
                 *     {@link String }
                 *     
                 */
                public void setNotificationMethod(String value) {
                    this.notificationMethod = value;
                }

                /**
                 * Gets the value of the timestamp property.
                 * 
                 * @return
                 *     possible object is
                 *     {@link XMLGregorianCalendar }
                 *     
                 */
                public XMLGregorianCalendar getTimestamp() {
                    return timestamp;
                }

                /**
                 * Sets the value of the timestamp property.
                 * 
                 * @param value
                 *     allowed object is
                 *     {@link XMLGregorianCalendar }
                 *     
                 */
                public void setTimestamp(XMLGregorianCalendar value) {
                    this.timestamp = value;
                }

            }

        }

    }

}
