
package at.gv.zustellung.zusemsg.xsd.zuse;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import at.gv.zustellung.zusemsg.xsd.zuse_persondata.CorporateBodyType;
import at.gv.zustellung.zusemsg.xsd.zuse_persondata.PhysicalPersonType;
import at.gv.zustellung.zusemsg.xsd.zuse_persondata.PostalAddressType;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;choice>
 *           &lt;element ref="{http://reference.e-government.gv.at/namespace/persondata/20020228#}PhysicalPerson"/>
 *           &lt;element ref="{http://reference.e-government.gv.at/namespace/persondata/20020228#}CorporateBody"/>
 *         &lt;/choice>
 *         &lt;element ref="{http://reference.e-government.gv.at/namespace/zustellung/msg}MailBox" minOccurs="0"/>
 *         &lt;element ref="{http://reference.e-government.gv.at/namespace/persondata/20020228#}PostalAddress" minOccurs="0"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "physicalPerson",
    "corporateBody",
    "mailBox",
    "postalAddress"
})
@XmlRootElement(name = "Receiver")
public class Receiver {

    @XmlElement(name = "PhysicalPerson", namespace = "http://reference.e-government.gv.at/namespace/persondata/20020228#")
    protected PhysicalPersonType physicalPerson;
    @XmlElement(name = "CorporateBody", namespace = "http://reference.e-government.gv.at/namespace/persondata/20020228#")
    protected CorporateBodyType corporateBody;
    @XmlElement(name = "MailBox")
    protected Object mailBox;
    @XmlElement(name = "PostalAddress", namespace = "http://reference.e-government.gv.at/namespace/persondata/20020228#")
    protected PostalAddressType postalAddress;

    /**
     * Gets the value of the physicalPerson property.
     * 
     * @return
     *     possible object is
     *     {@link PhysicalPersonType }
     *     
     */
    public PhysicalPersonType getPhysicalPerson() {
        return physicalPerson;
    }

    /**
     * Sets the value of the physicalPerson property.
     * 
     * @param value
     *     allowed object is
     *     {@link PhysicalPersonType }
     *     
     */
    public void setPhysicalPerson(PhysicalPersonType value) {
        this.physicalPerson = value;
    }

    /**
     * Gets the value of the corporateBody property.
     * 
     * @return
     *     possible object is
     *     {@link CorporateBodyType }
     *     
     */
    public CorporateBodyType getCorporateBody() {
        return corporateBody;
    }

    /**
     * Sets the value of the corporateBody property.
     * 
     * @param value
     *     allowed object is
     *     {@link CorporateBodyType }
     *     
     */
    public void setCorporateBody(CorporateBodyType value) {
        this.corporateBody = value;
    }

    /**
     * Gets the value of the mailBox property.
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public Object getMailBox() {
        return mailBox;
    }

    /**
     * Sets the value of the mailBox property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setMailBox(Object value) {
        this.mailBox = value;
    }

    /**
     * Gets the value of the postalAddress property.
     * 
     * @return
     *     possible object is
     *     {@link PostalAddressType }
     *     
     */
    public PostalAddressType getPostalAddress() {
        return postalAddress;
    }

    /**
     * Sets the value of the postalAddress property.
     * 
     * @param value
     *     allowed object is
     *     {@link PostalAddressType }
     *     
     */
    public void setPostalAddress(PostalAddressType value) {
        this.postalAddress = value;
    }

}
