
package at.gv.zustellung.zusemsg.xsd.zuse;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import at.gv.zustellung.zusemsg.xsd.zuse_persondata.AbstractAddressType;
import at.gv.zustellung.zusemsg.xsd.zuse_persondata.CorporateBodyType;
import at.gv.zustellung.zusemsg.xsd.zuse_persondata.InternetAddressType;
import at.gv.zustellung.zusemsg.xsd.zuse_persondata.PhysicalPersonType;
import at.gv.zustellung.zusemsg.xsd.zuse_persondata.PostalAddressType;
import at.gv.zustellung.zusemsg.xsd.zuse_persondata.TelephoneAddressType;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;choice>
 *           &lt;element name="Organisation">
 *             &lt;complexType>
 *               &lt;complexContent>
 *                 &lt;extension base="{http://reference.e-government.gv.at/namespace/persondata/20020228#}CorporateBodyType">
 *                   &lt;anyAttribute namespace='##other'/>
 *                 &lt;/extension>
 *               &lt;/complexContent>
 *             &lt;/complexType>
 *           &lt;/element>
 *           &lt;choice>
 *             &lt;element ref="{http://reference.e-government.gv.at/namespace/persondata/20020228#}PhysicalPerson"/>
 *             &lt;element ref="{http://reference.e-government.gv.at/namespace/persondata/20020228#}CorporateBody"/>
 *           &lt;/choice>
 *         &lt;/choice>
 *         &lt;element ref="{http://reference.e-government.gv.at/namespace/zustellung/msg}MailBox" minOccurs="0"/>
 *         &lt;element ref="{http://reference.e-government.gv.at/namespace/persondata/20020228#}Address" maxOccurs="unbounded"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "organisation",
    "physicalPerson",
    "corporateBody",
    "mailBox",
    "address"
})
@XmlRootElement(name = "Sender")
public class Sender {

    @XmlElement(name = "Organisation")
    protected Sender.Organisation organisation;
    @XmlElement(name = "PhysicalPerson", namespace = "http://reference.e-government.gv.at/namespace/persondata/20020228#")
    protected PhysicalPersonType physicalPerson;
    @XmlElement(name = "CorporateBody", namespace = "http://reference.e-government.gv.at/namespace/persondata/20020228#")
    protected CorporateBodyType corporateBody;
    @XmlElement(name = "MailBox")
    protected Object mailBox;
    @XmlElementRef(name = "Address", namespace = "http://reference.e-government.gv.at/namespace/persondata/20020228#", type = JAXBElement.class)
    protected List<JAXBElement<? extends AbstractAddressType>> address;

    /**
     * Gets the value of the organisation property.
     * 
     * @return
     *     possible object is
     *     {@link Sender.Organisation }
     *     
     */
    public Sender.Organisation getOrganisation() {
        return organisation;
    }

    /**
     * Sets the value of the organisation property.
     * 
     * @param value
     *     allowed object is
     *     {@link Sender.Organisation }
     *     
     */
    public void setOrganisation(Sender.Organisation value) {
        this.organisation = value;
    }

    /**
     * Gets the value of the physicalPerson property.
     * 
     * @return
     *     possible object is
     *     {@link PhysicalPersonType }
     *     
     */
    public PhysicalPersonType getPhysicalPerson() {
        return physicalPerson;
    }

    /**
     * Sets the value of the physicalPerson property.
     * 
     * @param value
     *     allowed object is
     *     {@link PhysicalPersonType }
     *     
     */
    public void setPhysicalPerson(PhysicalPersonType value) {
        this.physicalPerson = value;
    }

    /**
     * Gets the value of the corporateBody property.
     * 
     * @return
     *     possible object is
     *     {@link CorporateBodyType }
     *     
     */
    public CorporateBodyType getCorporateBody() {
        return corporateBody;
    }

    /**
     * Sets the value of the corporateBody property.
     * 
     * @param value
     *     allowed object is
     *     {@link CorporateBodyType }
     *     
     */
    public void setCorporateBody(CorporateBodyType value) {
        this.corporateBody = value;
    }

    /**
     * Gets the value of the mailBox property.
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public Object getMailBox() {
        return mailBox;
    }

    /**
     * Sets the value of the mailBox property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setMailBox(Object value) {
        this.mailBox = value;
    }

    /**
     * Gets the value of the address property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the address property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getAddress().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link JAXBElement }{@code <}{@link AbstractAddressType }{@code >}
     * {@link JAXBElement }{@code <}{@link PostalAddressType }{@code >}
     * {@link JAXBElement }{@code <}{@link InternetAddressType }{@code >}
     * {@link JAXBElement }{@code <}{@link TelephoneAddressType }{@code >}
     * 
     * 
     */
    public List<JAXBElement<? extends AbstractAddressType>> getAddress() {
        if (address == null) {
            address = new ArrayList<JAXBElement<? extends AbstractAddressType>>();
        }
        return this.address;
    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType>
     *   &lt;complexContent>
     *     &lt;extension base="{http://reference.e-government.gv.at/namespace/persondata/20020228#}CorporateBodyType">
     *       &lt;anyAttribute namespace='##other'/>
     *     &lt;/extension>
     *   &lt;/complexContent>
     * &lt;/complexType>
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "")
    public static class Organisation
        extends CorporateBodyType
    {


    }

}
